package com.ideabus.sdk_test;

import android.annotation.SuppressLint;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.NumberPicker;
import android.widget.Spinner;
import android.widget.Switch;
import android.widget.TextView;
import android.widget.Toast;

import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.Toolbar;

import com.ideabus.model.bluetooth.MyBluetoothLE;
import com.ideabus.model.data.CBPdataAndCalCBP;
import com.ideabus.model.data.DRecord;
import com.ideabus.model.data.DeviceInfo;
import com.ideabus.model.data.FunctionSettingValues;
import com.ideabus.model.data.SettingValues;
import com.ideabus.model.data.SettingValues5Period;
import com.ideabus.model.data.User;
import com.ideabus.model.data.VersionData;
import com.ideabus.model.protocol.WBO3Protocol;

import java.util.Arrays;
import java.util.stream.IntStream;


@SuppressLint({"UseSwitchCompatOrMaterialCode", "NonConstantResourceId"})
public class WBO3TestActivity extends AppCompatActivity implements
        WBO3Protocol.OnConnectStateListener, View.OnClickListener,
        WBO3Protocol.OnDataResponseListener, WBO3Protocol.OnNotifyStateListener,
        MyBluetoothLE.OnWriteStateListener {

    private final String TAG = "WBO3TestActivity";

    private ListView bpmList;
    private LogListAdapter logListAdapter;

    private boolean isSendPersonParam;
    private Toolbar toolbar;
    private boolean isConnecting;

    private SettingValues aSettingValues = new SettingValues();

    EditText editUserID;
    EditText editCBPindex;
    EditText editABPMStart;
    EditText editABPMEnd;
    EditText editABPMInt_first;
    EditText editABPMInt_second;
    EditText editHI_infPressure;
    EditText editCBPInt_first;
    EditText editCBPInt_second;

    Switch SW_checkhide;
    Switch SW_SEL_silent;
    Switch SW_CBP_zone1_meas_off;
    Switch SW_CBP_zone2_meas_off;

    Spinner editCBPRaw;

    final String[] lunchCBPRaw = {"No CBP Raw", "Low CBP Raw", "Full CBP Raw"};

    CBPdataAndCalCBP.Dformat aDformat = CBPdataAndCalCBP.Dformat.NoCBPRaw;

    int SWCBPindexMax = 0;
    int keepIdx = 0;

    // 5-Period
    private SettingValues5Period settingValues5Period = new SettingValues5Period();

    TextView p1Tag, p2Tag, p3Tag, p4Tag, p5Tag;
    TextView p1Switch, p2Switch, p3Switch, p4Switch, p5Switch;
    TextView etP1Start, etP2Start, etP3Start, etP4Start, etP5Start;
    TextView etP1End, etP2End, etP3End, etP4End, etP5End;
    TextView etP1Interval, etP2Interval, etP3Interval, etP4Interval, etP5Interval;
    TextView etHiPressue;
    Switch swCheckHide;
    Switch swP1slient, swP2slient, swP3slient, swP4slient, swP5slient;
    Switch swP1bp, swP2bp, swP3bp, swP4bp, swP5bp;
    Switch swP1cbp, swP2cbp, swP3cbp, swP4cbp, swP5cbp;
    LayoutInflater inflater;
    AlertDialog.Builder  builder;
    AlertDialog dialog;
    boolean abpmWriteState = false;
    //ArrayList<Integer> aList24hr;
    int[] aList24hr;

    public WBO3TestActivity() {
    }


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        //Initialize the body ester machine Bluetooth module

        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_wbo3test);

        initView();
        initParam();
        initListener();
    }

    private void initView() {
        toolbar = (Toolbar) findViewById(R.id.tool_bar);
        bpmList = (ListView) findViewById(R.id.bpm_list_view);

        editUserID = (EditText)findViewById(R.id.user_ID);

        editCBPindex = (EditText)findViewById(R.id.readCBP_index);

        editABPMStart = (EditText)findViewById(R.id.ABPMStart);
        editABPMEnd = (EditText)findViewById(R.id.ABPMEnd);
        editABPMInt_first = (EditText)findViewById(R.id.ABPMInt_first);
        editABPMInt_second = (EditText)findViewById(R.id.ABPMInt_second);
        editHI_infPressure = (EditText)findViewById(R.id.HI_infPressure);
        editCBPInt_first = (EditText)findViewById(R.id.CBPInt_first);
        editCBPInt_second = (EditText)findViewById(R.id.CBPInt_second);
        SW_checkhide = (Switch)findViewById(R.id.SW_checkhide);
        SW_SEL_silent = (Switch)findViewById(R.id.SW_SEL_silent);
        SW_CBP_zone1_meas_off = (Switch)findViewById(R.id.SW_CBP_zone1_meas_off);
        SW_CBP_zone2_meas_off = (Switch)findViewById(R.id.SW_CBP_zone2_meas_off);

        editCBPRaw = (Spinner)findViewById(R.id.readCBP_Raw);
        ArrayAdapter<String> lunchCBPRawList = new ArrayAdapter<>(WBO3TestActivity.this,
                android.R.layout.simple_spinner_dropdown_item, lunchCBPRaw);
        editCBPRaw.setAdapter(lunchCBPRawList);

        findViewById(R.id.buttonView).setVisibility(View.GONE);

        // 5 Period
        inflater = this.getLayoutInflater();
        builder = new AlertDialog.Builder(this);
        View dialogView = inflater.inflate(R.layout.o3abpm_layout, null);
        builder.setView(dialogView);
        builder.setTitle(" Write Settings ABPM ")
                .setView(dialogView)
                .setPositiveButton(" OK ", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        //dialog.dismiss();
                        if (abpmWriteState && !etHiPressue.getText().toString().equalsIgnoreCase("")) {
                            writeSettingValuse5Period();
                            dialog.dismiss();
                        }
                        ///else
                        ///{
                        ///    Toast.makeText(getApplicationContext(), "Highest Inflation Pressure must be have value.",
                        ///            Toast.LENGTH_LONG).show();
                        ///}
                    }
                })
                .setCancelable(true);

        dialog = builder.create();

        p1Tag = dialogView.findViewById(R.id.o3_p1);
        etP1Start = dialogView.findViewById(R.id.p1_starttext);
        etP1End = dialogView.findViewById(R.id.p1_endtext);
        etP1Interval = dialogView.findViewById(R.id.p1_intervaltext);

        p2Tag = dialogView.findViewById(R.id.o3_p2);
        etP2Start = dialogView.findViewById(R.id.p2_starttext);
        etP2End = dialogView.findViewById(R.id.p2_endtext);
        etP2Interval = dialogView.findViewById(R.id.p2_intervaltext);

        p3Tag = dialogView.findViewById(R.id.o3_p3);
        etP3Start = dialogView.findViewById(R.id.p3_starttext);
        etP3End = dialogView.findViewById(R.id.p3_endtext);
        etP3Interval = dialogView.findViewById(R.id.p3_intervaltext);

        p4Tag = dialogView.findViewById(R.id.o3_p4);
        etP4Start = dialogView.findViewById(R.id.p4_starttext);
        etP4End = dialogView.findViewById(R.id.p4_endtext);
        etP4Interval = dialogView.findViewById(R.id.p4_intervaltext);

        p5Tag = dialogView.findViewById(R.id.o3_p5);
        etP5Start = dialogView.findViewById(R.id.p5_starttext);
        etP5End = dialogView.findViewById(R.id.p5_endtext);
        etP5Interval = dialogView.findViewById(R.id.p5_intervaltext);

        etHiPressue = dialogView.findViewById(R.id.hinf_pressure);
        swCheckHide = dialogView.findViewById(R.id.o3_checkhide);

        p1Switch = dialogView.findViewById(R.id.o3_p1_sw);
        swP1slient = dialogView.findViewById(R.id.p1_sw_silent);
        swP1bp = dialogView.findViewById(R.id.p1_sw_bpmeas);
        swP1cbp = dialogView.findViewById(R.id.p1_sw_cbpmeas);

        p2Switch = dialogView.findViewById(R.id.o3_p2_sw);
        swP2slient = dialogView.findViewById(R.id.p2_sw_silent);
        swP2bp = dialogView.findViewById(R.id.p2_sw_bpmeas);
        swP2cbp = dialogView.findViewById(R.id.p2_sw_cbpmeas);

        p3Switch = dialogView.findViewById(R.id.o3_p3_sw);
        swP3slient = dialogView.findViewById(R.id.p3_sw_silent);
        swP3bp = dialogView.findViewById(R.id.p3_sw_bpmeas);
        swP3cbp = dialogView.findViewById(R.id.p3_sw_cbpmeas);

        p4Switch = dialogView.findViewById(R.id.o3_p4_sw);
        swP4slient = dialogView.findViewById(R.id.p4_sw_silent);
        swP4bp = dialogView.findViewById(R.id.p4_sw_bpmeas);
        swP4cbp = dialogView.findViewById(R.id.p4_sw_cbpmeas);

        p5Switch = dialogView.findViewById(R.id.o3_p5_sw);
        swP5slient = dialogView.findViewById(R.id.p5_sw_silent);
        swP5bp = dialogView.findViewById(R.id.p5_sw_bpmeas);
        swP5cbp = dialogView.findViewById(R.id.p5_sw_cbpmeas);

        // disable P1 ~ P5 for meas Off switch
        setPeriodUIStatus(false, 1);
        setPeriodUIStatus(false, 2);
        setPeriodUIStatus(false, 3);
        setPeriodUIStatus(false, 4);
        setPeriodUIStatus(false, 5);
    }

    private void setPeriodUIStatus(final boolean state, final int period) {
        switch (period) {
            case 1:
                p1Tag.setEnabled(state);
                etP1Start.setEnabled(state);
                etP1Interval.setEnabled(state);
                etP1End.setEnabled(state);
                p1Switch.setEnabled(state);
                swP1slient.setEnabled(state);
                swP1cbp.setEnabled(state);
                break;

            case 2:
                p2Tag.setEnabled(state);
                etP2Start.setEnabled(state);
                etP2Interval.setEnabled(state);
                etP2End.setEnabled(state);
                p2Switch.setEnabled(state);
                swP2slient.setEnabled(state);
                swP2cbp.setEnabled(state);
                break;

            case 3:
                p3Tag.setEnabled(state);
                etP3Start.setEnabled(state);
                etP3Interval.setEnabled(state);
                etP3End.setEnabled(state);
                p3Switch.setEnabled(state);
                swP3slient.setEnabled(state);
                swP3cbp.setEnabled(state);
                break;

            case 4:
                p4Tag.setEnabled(state);
                etP4Start.setEnabled(state);
                etP4Interval.setEnabled(state);
                etP4End.setEnabled(state);
                p4Switch.setEnabled(state);
                swP4slient.setEnabled(state);
                swP4cbp.setEnabled(state);
                break;

            case 5:
                p5Tag.setEnabled(state);
                etP5Start.setEnabled(state);
                etP5Interval.setEnabled(state);
                etP5End.setEnabled(state);
                p5Switch.setEnabled(state);
                swP5slient.setEnabled(state);
                swP5cbp.setEnabled(state);
                break;

            default:
                break;
        }
    }

    private void initParam() {
        setSupportActionBar(toolbar);

        //Initialize the connection SDK
        Global.wbo3Protocol = WBO3Protocol.getInstance(this, false,
                true, Global.sdkid_WBP);

        toolbar.setSubtitle("WatchBP O3 " + Global.wbo3Protocol.getSDKVersion());

        logListAdapter = new LogListAdapter(this);
        bpmList.setAdapter(logListAdapter);

        editABPMEnd.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                Log.w(TAG,"s: " + s + ", start: " + start + ", before: " + before + ", count: " + count );
            }

            @SuppressLint("SetTextI18n")
            @Override
            public void afterTextChanged(Editable s) {
                if (!s.toString().contains("")) {
                    int tmp = Integer.parseInt(s.toString());
                    int startVal = Integer.parseInt(editABPMStart.getText().toString());

                    if ((tmp < startVal) || editABPMEnd.getText().length() <= 0) {
                        editABPMEnd.setText(String.valueOf(startVal + 1));
                    }

                    editABPMEnd.setSelection(s.length());

                    if (tmp > 23)
                        editABPMEnd.setText("23");
                    // .toString())) &&
                    // (Integer.parseInt(s.toString()) < 24))
                    //{
                    //    showAlertDialog(s.toString() + " must be small than 24 and over then AMPM " +
                    //            "Start.");
                    //}
                    Log.w(TAG,"s: " + s );
                }
                else
                {
                    Log.e(TAG, "s is \"\"");
                }
            }
        });

        aList24hr = new int[24];
        for (int i=0; i<24; i++) {
            aList24hr[i] = i;
        }
        Log.w(TAG, "aList24hr: " + Arrays.toString(aList24hr));

        etHiPressue.setText("160");

    }

    private void setSV() {
        editABPMStart.setText(String.valueOf(aSettingValues.getABPMStart()));
        editABPMEnd.setText(String.valueOf(aSettingValues.getABPMEnd()));
        editABPMInt_first.setText(String.valueOf(aSettingValues.getABPMInt_first()));
        editABPMInt_second.setText(String.valueOf(aSettingValues.getABPMInt_second()));
        editHI_infPressure.setText(String.valueOf(aSettingValues.getHI_infPressure()));
        editCBPInt_first.setText(String.valueOf(aSettingValues.getCBPInt_first()));
        editCBPInt_second.setText(String.valueOf(aSettingValues.getCBPInt_second()));
        SW_checkhide.setChecked(aSettingValues.isSW_checkhide());
        SW_SEL_silent.setChecked(aSettingValues.isSW_SEL_silent());
        SW_CBP_zone1_meas_off.setChecked(aSettingValues.isCBP_zone1_meas_off());
        SW_CBP_zone2_meas_off.setChecked(aSettingValues.isCBP_zone2_meas_off());
    }

    private void set5Period()
    {
        etP1Start.setText(String.valueOf(settingValues5Period.getStartEndIntervals().get(0).getStartHour()));
        etP1End.setText(String.valueOf(settingValues5Period.getStartEndIntervals().get(0).getEndHour()));
        etP1Interval.setText(String.valueOf(settingValues5Period.getStartEndIntervals().get(0).getInterval()));

        etP2Start.setText(String.valueOf(settingValues5Period.getStartEndIntervals().get(1).getStartHour()));
        etP2End.setText(String.valueOf(settingValues5Period.getStartEndIntervals().get(1).getEndHour()));
        etP2Interval.setText(String.valueOf(settingValues5Period.getStartEndIntervals().get(1).getInterval()));

        etP3Start.setText(String.valueOf(settingValues5Period.getStartEndIntervals().get(2).getStartHour()));
        etP3End.setText(String.valueOf(settingValues5Period.getStartEndIntervals().get(2).getEndHour()));
        etP3Interval.setText(String.valueOf(settingValues5Period.getStartEndIntervals().get(2).getInterval()));

        etP4Start.setText(String.valueOf(settingValues5Period.getStartEndIntervals().get(3).getStartHour()));
        etP4End.setText(String.valueOf(settingValues5Period.getStartEndIntervals().get(3).getEndHour()));
        etP4Interval.setText(String.valueOf(settingValues5Period.getStartEndIntervals().get(3).getInterval()));

        etP5Start.setText(String.valueOf(settingValues5Period.getStartEndIntervals().get(4).getStartHour()));
        etP5End.setText(String.valueOf(settingValues5Period.getStartEndIntervals().get(4).getEndHour()));
        etP5Interval.setText(String.valueOf(settingValues5Period.getStartEndIntervals().get(4).getInterval()));

        etHiPressue.setText(String.valueOf(settingValues5Period.getHiPressure()));
        swCheckHide.setChecked(settingValues5Period.isCheckHide());

        swP1slient.setChecked(settingValues5Period.getStates().get(0).isSilent());
        swP1bp.setChecked(settingValues5Period.getStates().get(0).isBpMeasOff());
        swP1cbp.setChecked(settingValues5Period.getStates().get(0).isCbpMeasOff());

        swP2slient.setChecked(settingValues5Period.getStates().get(1).isSilent());
        swP2bp.setChecked(settingValues5Period.getStates().get(1).isBpMeasOff());
        swP2cbp.setChecked(settingValues5Period.getStates().get(1).isCbpMeasOff());

        swP3slient.setChecked(settingValues5Period.getStates().get(2).isSilent());
        swP3bp.setChecked(settingValues5Period.getStates().get(2).isBpMeasOff());
        swP3cbp.setChecked(settingValues5Period.getStates().get(2).isCbpMeasOff());

        swP4slient.setChecked(settingValues5Period.getStates().get(3).isSilent());
        swP4bp.setChecked(settingValues5Period.getStates().get(3).isBpMeasOff());
        swP4cbp.setChecked(settingValues5Period.getStates().get(3).isCbpMeasOff());

        swP5slient.setChecked(settingValues5Period.getStates().get(4).isSilent());
        swP5bp.setChecked(settingValues5Period.getStates().get(4).isBpMeasOff());
        swP5cbp.setChecked(settingValues5Period.getStates().get(4).isCbpMeasOff());

        setPeriodUIStatus(swP1bp.isChecked(), 1);
        setPeriodUIStatus(swP2bp.isChecked(), 2);
        setPeriodUIStatus(swP3bp.isChecked(), 3);
        setPeriodUIStatus(swP4bp.isChecked(), 4);
        setPeriodUIStatus(swP5bp.isChecked(), 5);
    }

    private void initListener() {
        findViewById(R.id.button1).setOnClickListener(this);
        findViewById(R.id.button2).setOnClickListener(this);
        findViewById(R.id.button3).setOnClickListener(this);
        findViewById(R.id.button4).setOnClickListener(this);
        findViewById(R.id.button5).setOnClickListener(this);
        findViewById(R.id.button6).setOnClickListener(this);
        findViewById(R.id.button7).setOnClickListener(this);
        findViewById(R.id.button8).setOnClickListener(this);
        findViewById(R.id.button9).setOnClickListener(this);
        findViewById(R.id.button10).setOnClickListener(this);
        findViewById(R.id.button11).setOnClickListener(this);
        findViewById(R.id.button12).setOnClickListener(this);
        findViewById(R.id.button13).setOnClickListener(this);
        findViewById(R.id.SW_CBP_zone2_meas_off).setOnClickListener(this);
        findViewById(R.id.SW_CBP_zone1_meas_off).setOnClickListener(this);
        findViewById(R.id.SW_SEL_silent).setOnClickListener(this);
        findViewById(R.id.SW_checkhide).setOnClickListener(this);
        editCBPRaw.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                switch (position) {
                    case 0:
                        aDformat = CBPdataAndCalCBP.Dformat.NoCBPRaw;
                        break;
                    case 1:
                        aDformat = CBPdataAndCalCBP.Dformat.LowCBPRaw;
                        break;
                    case 2:
                        aDformat = CBPdataAndCalCBP.Dformat.FullCBPRaw;
                        break;
                }
            }

            @Override
            public void onNothingSelected(AdapterView<?> parent) {}
        });

        findViewById(R.id.o3_button14).setOnClickListener(this::onClick);
        findViewById(R.id.o3_button14).setVisibility(View.INVISIBLE);

        findViewById(R.id.o3_button15).setOnClickListener(this::onClick);
        findViewById(R.id.o3_button15).setVisibility(View.INVISIBLE);


        swCheckHide.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                settingValues5Period.setCheckHide(isChecked);
                Log.w(TAG, "swCheckHide, isChecked: " + isChecked);
            }
        });

        swP1slient.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                settingValues5Period.getStates().get(0).setSilent(isChecked);
                Log.w(TAG, "swP1slient, isChecked: " + isChecked);
            }
        });

        swP2slient.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                settingValues5Period.getStates().get(1).setSilent(isChecked);
                Log.w(TAG, "swP2slient, isChecked: " + isChecked);
            }
        });

        swP3slient.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                settingValues5Period.getStates().get(2).setSilent(isChecked);
                Log.w(TAG, "swP3slient, isChecked: " + isChecked);
            }
        });

        swP4slient.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                settingValues5Period.getStates().get(3).setSilent(isChecked);
                Log.w(TAG, "swP4slient, isChecked: " + isChecked);
            }
        });

        swP5slient.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                settingValues5Period.getStates().get(4).setSilent(isChecked);
                Log.w(TAG, "swP5slient, isChecked: " + isChecked);
            }
        });


        swP1bp.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                settingValues5Period.getStates().get(0).setBpMeasOff(isChecked);
                Log.w(TAG, "swP1bp, isChecked: " + isChecked);
            }
        });

        swP2bp.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                settingValues5Period.getStates().get(1).setBpMeasOff(isChecked);
                Log.w(TAG, "swP2bp, isChecked: " + isChecked);
            }
        });

        swP3bp.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                settingValues5Period.getStates().get(2).setBpMeasOff(isChecked);
                Log.w(TAG, "swP2bp, isChecked: " + isChecked);
            }
        });

        swP4bp.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                settingValues5Period.getStates().get(3).setBpMeasOff(isChecked);
                Log.w(TAG, "swP2bp, isChecked: " + isChecked);
            }
        });

        swP5bp.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                settingValues5Period.getStates().get(4).setBpMeasOff(isChecked);
                Log.w(TAG, "swP2bp, isChecked: " + isChecked);
            }
        });

        swP1cbp.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                settingValues5Period.getStates().get(0).setCbpMeasOff(isChecked);
                Log.w(TAG, "swP1cbp, isChecked: " + isChecked);
            }
        });

        swP2cbp.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                settingValues5Period.getStates().get(1).setCbpMeasOff(isChecked);
                Log.w(TAG, "swP2cbp, isChecked: " + isChecked);
            }
        });

        swP3cbp.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                settingValues5Period.getStates().get(2).setCbpMeasOff(isChecked);
                Log.w(TAG, "swP3cbp, isChecked: " + isChecked);
            }
        });

        swP4cbp.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                settingValues5Period.getStates().get(3).setCbpMeasOff(isChecked);
                Log.w(TAG, "swP4cbp, isChecked: " + isChecked);
            }
        });

        swP5cbp.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                settingValues5Period.getStates().get(4).setCbpMeasOff(isChecked);
                Log.w(TAG, "swP5cbp, isChecked: " + isChecked);
            }
        });

    }

    @Override
    protected void onStart() {
        Log.d(TAG, "1026 onStart: " + Global.wbo3Protocol);
        super.onStart();
        Global.wbo3Protocol.setOnConnectStateListener(this);
        Global.wbo3Protocol.setOnDataResponseListener(this);
        Global.wbo3Protocol.setOnNotifyStateListener(this);
        Global.wbo3Protocol.setOnWriteStateListener(this);
        startScan();
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        if (Global.wbo3Protocol.isConnected()) Global.wbo3Protocol.disconnect();
        Global.wbo3Protocol.stopScan();
    }

    private void startScan() {
        if (!Global.wbo3Protocol.isSupportBluetooth(this)) {
            return;
        }
        logListAdapter.addLog("start scan");
        Global.wbo3Protocol.startScan(10);
    }

    @Override
    protected void onStop() {
        super.onStop();
        Global.wbo3Protocol.disconnect();
        Global.wbo3Protocol.stopScan();
    }

    @Override
    public void onClick(View view) {
        InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
        imm.hideSoftInputFromWindow(view.getWindowToken(), 0); //強制隱藏鍵盤
        Button btn = (Button)findViewById(view.getId());
        if (Global.wbo3Protocol.isConnected()) {
            switch (view.getId()) {
                case R.id.button1:
                    logListAdapter.addLog("WRITE : " + btn.getText().toString());
                    Global.wbo3Protocol.readAllHistorys();
                    break;
                case R.id.button2:
                    logListAdapter.addLog("WRITE : " + btn.getText().toString());
                    Global.wbo3Protocol.readSettingValues();
                    break;
                case R.id.button3:
                    logListAdapter.addLog("WRITE : " + btn.getText().toString());
                    Global.wbo3Protocol.readBTModuleName();
                    break;
                case R.id.button4:
                    logListAdapter.addLog("WRITE : " + btn.getText().toString());
                    Global.wbo3Protocol.readFunctionSettingValue();
                    break;
                case R.id.button5:
                    logListAdapter.addLog("WRITE : " + btn.getText().toString());
                    Global.wbo3Protocol.disconnectWBO3();
                    break;
                case R.id.button6:
                    logListAdapter.addLog("WRITE : " + btn.getText().toString());
                    Global.wbo3Protocol.readDeviceIDAndInfo();
                    break;
                case R.id.button7:
                    logListAdapter.addLog("WRITE : " + btn.getText().toString());
                    if (SWCBPindexMax > 0) {
                        if (SWCBPindexMax >= Integer.parseInt(editCBPindex.getText().toString()) &&
                            Integer.parseInt(editCBPindex.getText().toString()) > 0) {
                            Global.wbo3Protocol.readCBPData(Integer.parseInt(
                                    editCBPindex.getText().toString()), aDformat);
                        } else {
                            Toast.makeText(WBO3TestActivity.this,
                                    "The number of errors is optional.", Toast.LENGTH_SHORT).show();
                        }
                    } else {
                        Toast.makeText(WBO3TestActivity.this,
                                "Please read all history data first", Toast.LENGTH_SHORT).show();
                    }
                    break;
                case R.id.button8:
                    logListAdapter.addLog("WRITE : " + btn.getText().toString());
                    Global.wbo3Protocol.clearAllHistorys();
                    break;
                case R.id.button9:
                    logListAdapter.addLog("WRITE : " + btn.getText().toString());
                    Global.wbo3Protocol.writeUserID(editUserID.getText().toString());
                    break;
                case R.id.button10:
                    logListAdapter.addLog("WRITE : " + btn.getText().toString());
                    aSettingValues.setABPMStart(Integer.parseInt(editABPMStart.getText().toString()));
                    aSettingValues.setABPMEnd(Integer.parseInt(editABPMEnd.getText().toString()));
                    aSettingValues.setABPMInt_first(Integer.parseInt(editABPMInt_first.getText().toString()));
                    aSettingValues.setABPMInt_second(Integer.parseInt(editABPMInt_second.getText().toString()));
                    aSettingValues.setHI_infPressure(Integer.parseInt(editHI_infPressure.getText().toString()));
                    aSettingValues.setCBPInt_first(Integer.parseInt(editCBPInt_first.getText().toString()));
                    aSettingValues.setCBPInt_second(Integer.parseInt(editCBPInt_second.getText().toString()));
                    //if ((aSettingValues.getABPMInt_first() >= aSettingValues.getCBPInt_first()) ||
                    //    (aSettingValues.getABPMInt_second()>= aSettingValues.getCBPInt_second()) )
                    //{
                    //    showAlertDialog("ABPM interval first or second must be small then " +
                    //            "CBP interval first or second.");
                    //}

                    //if (checkSettingValue(aSettingValues))
                    //{
                    //    logListAdapter.addLog("Write： Fail !!, value has error.");
                    //    return;
                    //}
                    Global.wbo3Protocol.writeSettingValues(aSettingValues);

                    break;
                case R.id.button11:
                    logListAdapter.addLog("WRITE : " + btn.getText().toString());
                    Global.wbo3Protocol.readDeviceTime();
                    break;
                case R.id.button12:
                    logListAdapter.addLog("WRITE : " + btn.getText().toString());
                    Global.wbo3Protocol.writeDeviceTime();
                    break;
                case R.id.button13:
                    logListAdapter.addLog("WRITE : " + btn.getText().toString());
                    Global.wbo3Protocol.readUserAndVersionData();
                    break;
                case R.id.SW_CBP_zone2_meas_off:
                    aSettingValues.setCBP_zone2_meas_off(!aSettingValues.isCBP_zone2_meas_off());
                    logListAdapter.addLog("WRITE : setCBP_zone2_meas_off : " + aSettingValues.isCBP_zone2_meas_off());
                    break;
                case R.id.SW_CBP_zone1_meas_off:
                    aSettingValues.setCBP_zone1_meas_off(!aSettingValues.isCBP_zone1_meas_off());
                    logListAdapter.addLog("WRITE : setCBP_zone1_meas_off : " + aSettingValues.isCBP_zone1_meas_off());
                    break;
                case R.id.SW_SEL_silent:
                    aSettingValues.setSW_SEL_silent(!aSettingValues.isSW_SEL_silent());
                    logListAdapter.addLog("WRITE : setSW_SEL_silent : " + aSettingValues.isSW_SEL_silent());
                    break;
                case R.id.SW_checkhide:
                    aSettingValues.setSW_checkhide(!aSettingValues.isSW_checkhide());
                    logListAdapter.addLog("WRITE : setSW_checkhide : " + aSettingValues.isSW_checkhide());
                    break;

                case R.id.o3_button14:
                    logListAdapter.addLog("WRITE : " + btn.getText().toString());
                    Global.wbo3Protocol.readSettingValues_5Period();
                    break;

                case R.id.o3_button15:
                    abpmWriteState = true;
                    logListAdapter.addLog("WRITE : " + btn.getText().toString());
                    ///if (keepIdx >= 23)
                    keepIdx =0;

                    checkSWState();
                    //setWriteDefault();
                    //Global.wbo3Protocol.writeSettingValues_5Period(new SettingValues());
                    dialog.setTitle(" Write Settings ABPM ");
                    dialog.show();
                    break;

                case R.id.p1_starttext:
                    ///keepIdx = 0;
                    String tmpValue = etP1Start.getText().toString();
                    setHour(etP1Start);
                    ///aList24hr.set(0, Integer.parseInt(tmpValue));
                    //setNewList(Integer.parseInt(tmpValue));
                    break;

                case R.id.p2_starttext:
                    setHour(etP2Start);
                    break;

                case R.id.p3_starttext:
                    setHour(etP3Start);
                    break;

                case R.id.p4_starttext:
                    setHour(etP4Start);
                    break;

                case R.id.p5_starttext:
                    setHour(etP5Start);
                    break;

                case R.id.p1_endtext:
                    setHour(etP1End);
                    break;

                case R.id.p2_endtext:
                    setHour(etP2End);
                    break;

                 case R.id.p3_endtext:
                    setHour(etP3End);
                    break;
                case R.id.p4_endtext:
                    setHour(etP4End);
                    break;
                case R.id.p5_endtext:
                    setHour(etP5End);
                    break;

                case R.id.p1_intervaltext:
                    setInterval(etP1Interval);
                    break;
                case R.id.p2_intervaltext:
                    setInterval(etP2Interval);
                    break;
                case R.id.p3_intervaltext:
                    setInterval(etP3Interval);
                    break;
                case R.id.p4_intervaltext:
                    setInterval(etP4Interval);
                    break;
                case R.id.p5_intervaltext:
                    setInterval(etP5Interval);
                    break;

                case R.id.hinf_pressure:
                    setPressure(etHiPressue);
                    break;

                case R.id.p1_sw_bpmeas:
                    if (swP1bp.isChecked())
                        setPeriodUIStatus(true, 1);
                    else
                        setPeriodUIStatus(false, 1);
                    break;

                case R.id.p2_sw_bpmeas:
                    ///if ((keepIdx < 24) && swP2bp.isChecked())
                    if (swP2bp.isChecked())
                        setPeriodUIStatus(true, 2);
                    else
                        setPeriodUIStatus(false, 2);
                    break;

                case R.id.p3_sw_bpmeas:
                    ///if ((keepIdx < 24) && swP3bp.isChecked())
                    if (swP3bp.isChecked())
                        setPeriodUIStatus(true, 3);
                    else
                        setPeriodUIStatus(false, 3);
                    break;

                case R.id.p4_sw_bpmeas:
                    ///if ((keepIdx < 24) && swP4bp.isChecked())
                    if (swP4bp.isChecked())
                        setPeriodUIStatus(true, 4);
                    else
                        setPeriodUIStatus(false, 4);
                    break;

                case R.id.p5_sw_bpmeas:
                    ///if ((keepIdx < 24) && swP5bp.isChecked())
                    if (swP5bp.isChecked())
                        setPeriodUIStatus(true, 5);
                    else
                        setPeriodUIStatus(false, 5);
                    break;

            }
        }
    }

    private void setNewList(int startValue)
    {
        for (int i=0; i<aList24hr.length; i++)
        {
            int tmpValue = i+startValue;
            if (tmpValue > 23)
                tmpValue -= 24;
            aList24hr[i] = tmpValue;
        }
        Log.w(TAG, "setNewList(" + startValue + "), aList24hr: " + Arrays.toString(aList24hr));
    }

    private int getListIndex(int value)
    {
        return IntStream.range(0, aList24hr.length)
                .filter( i -> aList24hr[i] == value)
                .findFirst()
                .orElse(-1);
    }


    private boolean checkSettingValue(SettingValues values)
    {
        boolean tmpState = false;
        if ((values.getABPMStart() < 6) && (values.getABPMStart() > 23)) {
            showAlertDialog("ABPM Start Error !! 6 <= ABPM Start < 24");
            tmpState = true;
        }

        //if ((values.getABPMEnd() < values.getABPMStart()) || (values.getABPMEnd() > 24))
        if ((values.getABPMEnd() > 23))
        {
            //showAlertDialog("ABPM end Error !! ABPM end < start or ABPM end > 24");
            showAlertDialog("ABPM end > 23");
            tmpState = true;
        }

        if (values.getABPMInt_second() < values.getABPMInt_first()) {
            showAlertDialog("ABPM Interval Error !! ABPM first inerval > second interval");
            tmpState = true;
        }

        if (values.getCBPInt_second() < values.getCBPInt_first()) {
            showAlertDialog("CBP Interval Error !! CBP first inerval > second interval");
            tmpState = true;
        }

        if (values.getAUS_HI_infPressure() > 280)
        {
            showAlertDialog("Error!! Hi inflation pressure < 280, ");
            tmpState = true;
        }

        return tmpState;
    }

    private void setHour(final TextView tmpTV)
    {
        //Log.w(TAG, "setHour, ");
        android.app.AlertDialog.Builder builder = new android.app.AlertDialog.Builder(WBO3TestActivity.this);
        final View view = this.getLayoutInflater().inflate(R.layout.dialog_picker_number_layout2, null);
        builder.setView(view);
        final NumberPicker picker = view.findViewById(R.id.np02);
        picker.setMinValue(0);
        picker.setMaxValue(aList24hr.length-1);
        picker.setValue(aList24hr[keepIdx]);
        picker.setFormatter(new NumberPicker.Formatter() {
            @Override
            public String format(int value) {
                return String.valueOf(aList24hr[value]);
            }
        });

        picker.setWrapSelectorWheel(true);
        picker.setOnValueChangedListener(new NumberPicker.OnValueChangeListener() {
            @Override
            public void onValueChange(NumberPicker numberPicker, int i, int i1) {

                //if ((numberPicker.getValue() > keepIdx)) {
                //    keepIdx = numberPicker.getValue();
                    //finalNumber = String.valueOf(keepIdx);
                //}
                //else
                //{
                //    Toast.makeText(view.getContext(), "Error !! set value < smaller than last " +
                //            "value.", Toast.LENGTH_SHORT).show();
                //}
                ///keepIdx = getListIndex(i);
            }
        });

        builder.setTitle("set Hour")
                .setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialogInterface, int i) {
                        dialogInterface.dismiss();
                    }
                })
                .setPositiveButton("OK", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialogInterface, int i) {

                        keepIdx = picker.getValue();
                        ///if (tmpTV.getId() == R.id.p1_starttext)
                        ///{
                        ///    setNewList(picker.getValue());
                        ///    keepIdx = 0;
                        ///    ///tmpTV.setText(aList24hr.get(keepIdx));
                        ///}

                        tmpTV.setText(String.valueOf(aList24hr[keepIdx]));
                        Log.w(TAG, "keep: " + keepIdx);
                        ///if (keepIdx >= 23)
                        ///    keepIdx++;
                        dialogInterface.dismiss();
                    }
                })
                .show();
    }

    @SuppressLint("NewApi")
    private void setInterval(final TextView tmpTV)
    {
        Log.w(TAG, "setInterval, ");
        final int[] data = {5, 10, 15, 20, 30, 60};
        final String[] dataStr = Arrays.stream(data).mapToObj(String::valueOf)
                .toArray(String[]::new);

        Log.w(TAG, "dataStr: " + Arrays.deepToString(dataStr));
        android.app.AlertDialog.Builder builder = new android.app.AlertDialog.Builder(WBO3TestActivity.this);

        final View view = this.getLayoutInflater().inflate(R.layout.dialog_picker_number_layout2,
                null);
        builder.setView(view);
        final NumberPicker picker = view.findViewById(R.id.np02);
        picker.setMinValue(1);
        picker.setMaxValue(data.length);
        Log.w(TAG, "picker.getValue(): " + picker.getValue());
        //if (picker.getValue() <= 0 ) {
        picker.setValue(data[0]);
        //}
        picker.setDisplayedValues(dataStr);
        picker.setOnValueChangedListener(new NumberPicker.OnValueChangeListener() {
            @Override
            public void onValueChange(NumberPicker numberPicker, int i, int i1) {
                //finalNumber = String.valueOf(numberPicker.getValue());
            }
        });

        builder.setTitle(" Interval ")
                .setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialogInterface, int i) {
                        dialogInterface.dismiss();
                    }
                })
                .setPositiveButton("OK", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialogInterface, int i) {
                        tmpTV.setText(String.valueOf(data[picker.getValue()-1]));
                        dialogInterface.dismiss();
                    }
                }).show();
    }

    private void setPressure(final TextView tmpTV)
    {
        Log.w(TAG, "setInterval, ");
        final int[] data = {0, 140, 160, 180, 200, 220, 240, 280};
        final String[] dataStr = Arrays.stream(data).mapToObj(String::valueOf)
                .toArray(String[]::new);

        Log.w(TAG, "dataStr: " + Arrays.deepToString(dataStr));
        android.app.AlertDialog.Builder builder = new android.app.AlertDialog.Builder(WBO3TestActivity.this);

        final View view = this.getLayoutInflater().inflate(R.layout.dialog_picker_number_layout2,
                null);
        builder.setView(view);
        final NumberPicker picker = view.findViewById(R.id.np02);
        picker.setMinValue(1);
        picker.setMaxValue(data.length);
        Log.w(TAG, "picker.getValue(): " + picker.getValue());
        //if (picker.getValue() <= 0 ) {
        picker.setValue(data[0]);
        //}
        picker.setDisplayedValues(dataStr);
        picker.setOnValueChangedListener(new NumberPicker.OnValueChangeListener() {
            @Override
            public void onValueChange(NumberPicker numberPicker, int i, int i1) {
                //tmpTV.setText(String.valueOf(numberPicker.getValue()));
                Log.w(TAG, "onValueChange(), i: " + i + ", i1:" + i1);
            }
        });

        builder.setTitle(" Interval ")
                .setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialogInterface, int i) {
                        dialogInterface.dismiss();
                    }
                })
                .setPositiveButton("OK", new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialogInterface, int i) {
                        Log.w(TAG, "picker.getValue(): "+ picker.getValue() +
                                        ", data: " + data[picker.getValue()-1]+
                                        ", i: " + i);
                        tmpTV.setText(String.valueOf(data[picker.getValue()-1]));
                        dialogInterface.dismiss();
                    }
                }).show();
    }

    private void checkSWState()
    {
        if (swP1bp.isChecked())
        {
            keepIdx = Integer.parseInt(etP1End.getText().toString());
        }

        if (swP2bp.isChecked())
        {
            keepIdx = Integer.parseInt(etP2End.getText().toString());
        }

        if (swP3bp.isChecked())
        {
            keepIdx = Integer.parseInt(etP3End.getText().toString());
        }

        if (swP4bp.isChecked())
        {
            keepIdx = Integer.parseInt(etP4End.getText().toString());
        }

        if (swP5bp.isChecked())
        {
            keepIdx = 0;
        }
    }

    private void setWriteDefault()
    {
        if ((settingValues5Period.getStartEndIntervals() == null) ||
            (settingValues5Period.getStartEndIntervals().size() == 0) ||
            (settingValues5Period.getStates() == null) ||
            (settingValues5Period.getStates().size() == 0))
        {
           settingValues5Period.getStartEndIntervals().get(0).setStartHour(7);
           settingValues5Period.getStartEndIntervals().get(0).setEndHour(22);
           settingValues5Period.getStartEndIntervals().get(0).setInterval(30);

           settingValues5Period.getStartEndIntervals().get(1).setStartHour(22);
           settingValues5Period.getStartEndIntervals().get(1).setEndHour(7);
           settingValues5Period.getStartEndIntervals().get(1).setInterval(30);

           settingValues5Period.getStartEndIntervals().get(2).setStartHour(255); // 255: disable
           settingValues5Period.getStartEndIntervals().get(2).setEndHour(255);
           settingValues5Period.getStartEndIntervals().get(2).setInterval(255);

           settingValues5Period.getStartEndIntervals().get(3).setStartHour(255);
           settingValues5Period.getStartEndIntervals().get(3).setEndHour(255);
           settingValues5Period.getStartEndIntervals().get(3).setInterval(255);

           settingValues5Period.getStartEndIntervals().get(4).setStartHour(255);
           settingValues5Period.getStartEndIntervals().get(4).setEndHour(255);
           settingValues5Period.getStartEndIntervals().get(4).setInterval(255);

           settingValues5Period.setHiPressure(180);
           settingValues5Period.setCheckHide(true);     // 0: Enable display,  1: Disable display

           settingValues5Period.getStates().get(0).setSilent(true);    // 0: Enable,  1: Disable
           settingValues5Period.getStates().get(0).setBpMeasOff(true);
           settingValues5Period.getStates().get(0).setCbpMeasOff(true);
           settingValues5Period.getStates().get(1).setSilent(true);
           settingValues5Period.getStates().get(1).setBpMeasOff(true);
           settingValues5Period.getStates().get(1).setCbpMeasOff(true);
           settingValues5Period.getStates().get(2).setSilent(true);
           settingValues5Period.getStates().get(2).setBpMeasOff(true);
           settingValues5Period.getStates().get(2).setCbpMeasOff(true);
           settingValues5Period.getStates().get(3).setSilent(true);
           settingValues5Period.getStates().get(3).setBpMeasOff(true);
           settingValues5Period.getStates().get(3).setCbpMeasOff(true);
           settingValues5Period.getStates().get(4).setSilent(true);
           settingValues5Period.getStates().get(4).setBpMeasOff(true);
           settingValues5Period.getStates().get(4).setCbpMeasOff(true);
           set5Period();
        }
    }

    public void writeSettingValuse5Period()
    {
        //setWriteDefault();
        Log.w(TAG, "swP1bp: " + swP1bp.isChecked() + ", swP2bp: " + swP2bp.isChecked() +
                ", swP3bp: " + swP3bp.isChecked() + ", swP4bp: " + swP4bp.isChecked() +
                ", swP5bp: " + swP5bp.isChecked());

        try {
            if (swP1bp.isChecked())
            {
                //settingValues5Period.getStartEndIntervals().get(0).setStartHour(Integer
                // .parseInt(etP1Start.getText().toString()));
                settingValues5Period.getStartEndIntervals().get(0).setStartHour(Integer.parseInt(etP1Start.getText().toString()) );
                settingValues5Period.getStartEndIntervals().get(0).setEndHour(Integer.parseInt(etP1End.getText().toString()));
                settingValues5Period.getStartEndIntervals().get(0).setInterval(Integer.parseInt(etP1Interval.getText().toString()));
                settingValues5Period.getStates().get(0).setSilent(swP1slient.isChecked());
                settingValues5Period.getStates().get(0).setBpMeasOff(swP1bp.isChecked());
                settingValues5Period.getStates().get(0).setCbpMeasOff(swP1cbp.isChecked());
            }
            else
            {
                settingValues5Period.getStartEndIntervals().get(0).setStartHour(7);
                settingValues5Period.getStartEndIntervals().get(0).setEndHour(22);
                settingValues5Period.getStartEndIntervals().get(0).setInterval(30);
                settingValues5Period.getStates().get(0).setSilent(true);    // 0: Enable,  1: Disable
                settingValues5Period.getStates().get(0).setBpMeasOff(true);
                settingValues5Period.getStates().get(0).setCbpMeasOff(true);
            }

            if (swP2bp.isChecked()) {
                settingValues5Period.getStartEndIntervals().get(1).setStartHour(Integer.parseInt(etP2Start.getText().toString()));
                settingValues5Period.getStartEndIntervals().get(1).setEndHour(Integer.parseInt(etP2End.getText().toString()));
                settingValues5Period.getStartEndIntervals().get(1).setInterval(Integer.parseInt(etP2Interval.getText().toString()));
                settingValues5Period.getStates().get(1).setSilent(swP2slient.isChecked());
                settingValues5Period.getStates().get(1).setBpMeasOff(swP2bp.isChecked());
                settingValues5Period.getStates().get(1).setCbpMeasOff(swP2cbp.isChecked());

            }
            else
            {
                settingValues5Period.getStartEndIntervals().get(1).setStartHour(22);
                settingValues5Period.getStartEndIntervals().get(1).setEndHour(7);
                settingValues5Period.getStartEndIntervals().get(1).setInterval(30);
                settingValues5Period.getStates().get(1).setSilent(true);
                settingValues5Period.getStates().get(1).setBpMeasOff(true);
                settingValues5Period.getStates().get(1).setCbpMeasOff(true);
            }

            if (swP3bp.isChecked()) {
                settingValues5Period.getStartEndIntervals().get(2).setStartHour(Integer.parseInt(etP3Start.getText().toString()));
                settingValues5Period.getStartEndIntervals().get(2).setEndHour(Integer.parseInt(etP3End.getText().toString()));
                settingValues5Period.getStartEndIntervals().get(2).setInterval(Integer.parseInt(etP3Interval.getText().toString()));
                settingValues5Period.getStates().get(2).setSilent(swP3slient.isChecked());
                settingValues5Period.getStates().get(2).setBpMeasOff(swP3bp.isChecked());
                settingValues5Period.getStates().get(2).setCbpMeasOff(swP3cbp.isChecked());
            }
            else
            {
                settingValues5Period.getStartEndIntervals().get(2).setStartHour(255); // 255: disable
                settingValues5Period.getStartEndIntervals().get(2).setEndHour(255);
                settingValues5Period.getStartEndIntervals().get(2).setInterval(255);
                settingValues5Period.getStates().get(2).setSilent(false);
                settingValues5Period.getStates().get(2).setBpMeasOff(false);
                settingValues5Period.getStates().get(2).setCbpMeasOff(false);
            }

            if (swP4bp.isChecked()) {
                settingValues5Period.getStartEndIntervals().get(3).setStartHour(Integer.parseInt(etP4Start.getText().toString()));
                settingValues5Period.getStartEndIntervals().get(3).setEndHour(Integer.parseInt(etP4End.getText().toString()));
                settingValues5Period.getStartEndIntervals().get(3).setInterval(Integer.parseInt(etP4Interval.getText().toString()));
                settingValues5Period.getStates().get(3).setSilent(swP4slient.isChecked());
                settingValues5Period.getStates().get(3).setBpMeasOff(swP4bp.isChecked());
                settingValues5Period.getStates().get(3).setCbpMeasOff(swP4cbp.isChecked());
            }
            else
            {
                settingValues5Period.getStartEndIntervals().get(3).setStartHour(255);
                settingValues5Period.getStartEndIntervals().get(3).setEndHour(255);
                settingValues5Period.getStartEndIntervals().get(3).setInterval(255);
                settingValues5Period.getStates().get(3).setSilent(false);
                settingValues5Period.getStates().get(3).setBpMeasOff(false);
                settingValues5Period.getStates().get(3).setCbpMeasOff(false);
            }

            if (swP5bp.isChecked()) {
                settingValues5Period.getStartEndIntervals().get(4).setStartHour(Integer.parseInt(etP5Start.getText().toString()));
                settingValues5Period.getStartEndIntervals().get(4).setEndHour(Integer.parseInt(etP5End.getText().toString()));
                settingValues5Period.getStartEndIntervals().get(4).setInterval(Integer.parseInt(etP5Interval.getText().toString()));
                settingValues5Period.getStates().get(4).setSilent(swP5slient.isChecked());
                settingValues5Period.getStates().get(4).setBpMeasOff(swP5bp.isChecked());
                settingValues5Period.getStates().get(4).setCbpMeasOff(swP5cbp.isChecked());
            }
            else
            {
                settingValues5Period.getStartEndIntervals().get(4).setStartHour(255);
                settingValues5Period.getStartEndIntervals().get(4).setEndHour(255);
                settingValues5Period.getStartEndIntervals().get(4).setInterval(255);
                settingValues5Period.getStates().get(4).setSilent(false);
                settingValues5Period.getStates().get(4).setBpMeasOff(false);
                settingValues5Period.getStates().get(4).setCbpMeasOff(false);
            }

            int value = Integer.parseInt(etHiPressue.getText().toString());
            Log.w(TAG, " value: " + value);

            if (etHiPressue.getText().toString().equalsIgnoreCase("") ||
                etHiPressue == null) {
                value = 0;
            }
            
            if (value > 280) {
                value = 280;
            } else if ((value < 140) && (value > 1) ) {
                value = 140;
            }
            else if (value < -1) {
                value = 0;
            }
            etHiPressue.setText(String.valueOf(value));
            settingValues5Period.setHiPressure(value);
            settingValues5Period.setCheckHide(swCheckHide.isChecked());

            Log.w(TAG, "Global.wbo3Protocol.isConnected(): " + Global.wbo3Protocol.isConnected() +
                    ", swP1bp: " + swP1bp.isChecked() + ", swP2bp: " + swP2bp.isChecked() +
                    ", swP3bp: " + swP3bp.isChecked() + ", swP4bp: " + swP4bp.isChecked() +
                    ", swP5bp: " + swP5bp.isChecked());

            if (Global.wbo3Protocol.isConnected() && (swP1bp.isChecked() || swP2bp.isChecked() ||
                swP3bp.isChecked() || swP4bp.isChecked() ||swP5bp.isChecked())) {
                Log.w(TAG,"writeSettingValuse5Period(), settingValues5Period: "
                        + settingValues5Period);
                Global.wbo3Protocol.writeSettingValues_5Period(settingValues5Period);
            }
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }


    private void showAlertDialog(final String message)
    {
        AlertDialog.Builder builder = new AlertDialog.Builder(this);
        builder.setMessage(message)
               .setCancelable(false)
               .setPositiveButton(" OK ", new DialogInterface.OnClickListener() {
                   @Override
                   public void onClick(DialogInterface dialog, int which) {
                       dialog.dismiss();
                   }
               })
               .create()
               .show();
    }


    @Override
    public void onWriteMessage(boolean isSuccess, String message) {
        logListAdapter.addLog("WRITE : " + message);
    }

    @Override
    public void onNotifyMessage(String message) {
        logListAdapter.addLog("NOTIFY : " + message);
    }

    @Override
    public void onBtStateChanged(boolean isEnable) {
        //BLE will be returned when it is turned enable or disable
        if (isEnable) {
            Toast.makeText(this, "BLE is enable!!", Toast.LENGTH_SHORT).show();
            startScan();
        } else {
            Toast.makeText(this, "BLE is disable!!", Toast.LENGTH_SHORT).show();
        }
    }

    @Override
    public void onScanResult(String mac, String name, int rssi) {
        if (!name.startsWith("n/a")) {
            logListAdapter.addLog("onScanResult：" + name + ", mac: "+ mac + ", rssi:" + rssi);
        }

        if (name.startsWith("WatchBP O3") ||
            name.startsWith("Watch BP O3")) {
            if (isConnecting)
                return;

            isConnecting = true;
            //Stop scanning before connecting
            Global.wbo3Protocol.stopScan();
            //Connection
            Global.wbo3Protocol.bond(mac);
            logListAdapter.addLog("bond：" + mac);
        }
    }

    @Override
    public void onConnectionState(WBO3Protocol.ConnectState state) {
        switch (state) {
            case Connected:
                isConnecting = false;
                findViewById(R.id.buttonView).setVisibility(View.VISIBLE);
                logListAdapter.addLog("Connected");
                break;
            case ConnectTimeout:
                isConnecting = false;
                findViewById(R.id.buttonView).setVisibility(View.GONE);
                logListAdapter.addLog("ConnectTimeout");
                break;
            case Disconnect:
                isConnecting = false;
                findViewById(R.id.buttonView).setVisibility(View.GONE);
                logListAdapter.addLog("Disconnected");
                SWCBPindexMax = 0;
                startScan();
                break;
            case ScanFinish:
                findViewById(R.id.buttonView).setVisibility(View.GONE);
                logListAdapter.addLog("ScanFinish");
                startScan();
                break;
        }
    }

    @Override
    public void onResponseReadAllHistorys(DRecord dRecord) {
        logListAdapter.addLog("onResponseReadAllHistorys：" + dRecord);
        SWCBPindexMax = dRecord.getMData().size();
        editCBPindex.setText(String.valueOf(SWCBPindexMax));
    }

    @Override
    public void onResponseReadCBPData(CBPdataAndCalCBP cRecord,boolean isNullData) {
        logListAdapter.addLog("onResponseReadCBPData：" + cRecord + "\nis Null Data：" + isNullData);
    }

    @Override
    public void onResponseClearHistorys(boolean isSuccess) {
        logListAdapter.addLog("onResponseClearHistorys：" + isSuccess);
    }

    @Override
    public void onResponseReadUserAndVersionData(User user, VersionData versionData) {
        logListAdapter.addLog("onResponseReadUser:：" + user + "\nVersionData：" + versionData);
        editUserID.setText(user.getID());

        findViewById(R.id.o3_button14).setVisibility(View.VISIBLE);
        findViewById(R.id.o3_button15).setVisibility(View.VISIBLE);
    }

    @Override
    public void onResponseWriteUserID(boolean isSuccess) {
        logListAdapter.addLog("onResponseWriteUserID：" + isSuccess);
    }

    @Override
    public void onResponseReadSettingValues(SettingValues settingValues) {
        logListAdapter.addLog("onResponseReadSettingValues：" + settingValues);
        aSettingValues.setABPMStart(settingValues.getABPMStart());
        aSettingValues.setABPMEnd(settingValues.getABPMEnd());
        aSettingValues.setABPMInt_first(settingValues.getABPMInt_first());
        aSettingValues.setABPMInt_second(settingValues.getABPMInt_second());
        aSettingValues.setHI_infPressure(settingValues.getHI_infPressure());
        aSettingValues.setCBP_zone2_meas_off(settingValues.isCBP_zone2_meas_off());
        aSettingValues.setCBP_zone1_meas_off(settingValues.isCBP_zone1_meas_off());
        aSettingValues.setSW_SEL_silent(settingValues.isSW_SEL_silent());
        aSettingValues.setSW_checkhide(settingValues.isSW_checkhide());
        aSettingValues.setCBPInt_first(settingValues.getCBPInt_first());
        aSettingValues.setCBPInt_second(settingValues.getCBPInt_second());
        setSV();
    }

    @Override
    public void onResponseWriteSettingValues(boolean isSuccess) {
        logListAdapter.addLog("onResponseWriteSettingValues：" + isSuccess);
    }

    @Override
    public void onResponseReadDeviceInfo(DeviceInfo deviceInfo) {
        logListAdapter.addLog("onResponseReadDeviceInfo：" + deviceInfo);
    }

    @Override
    public void onResponseReadDeviceTime(DeviceInfo deviceInfo) {
        logListAdapter.addLog("onResponseReadDeviceTime：" + deviceInfo);
    }

    @Override
    public void onResponseWriteDeviceTime(boolean isSuccess) {
        logListAdapter.addLog("onResponseWriteDeviceTime：" + isSuccess);
    }

    @Override
    public void onResponseReadFunctionSettingValues(FunctionSettingValues functionSettingValues) {
        logListAdapter.addLog("onResponseReadFunctionSettingValues：" + functionSettingValues);
    }

    @Override
    public void onResponseReadBTModuleName(String BTModuleName) {
        logListAdapter.addLog("onResponseReadBTModuleName：" + BTModuleName);
    }

    @Override
    public void onResponseReadABPMSettingValues(SettingValues5Period values) {
        logListAdapter.addLog("onResponseReadABPMSettingValues: " + values );
        settingValues5Period = values;
        ///Log.w(TAG, "settingValues5Period: " + settingValues5Period);
        set5Period();

        if (dialog != null) {
            abpmWriteState = false;
            dialog.setTitle(" Read Settings ABPM ");
            dialog.show();
        }
    }

    @Override
    public void onResponseWriteABPMSettingValues(boolean b) {
        //Log.w(TAG, "onResponseWriteABPMSettingValues(), b: " + b);
        logListAdapter.addLog("onResponseWriteABPMSettingValues(), b: " + b);;
    }


}
